function [complex_ppi complex_density,Degree] = ComplexDensity(ComplexNum, ComplexProtein, PPI1, PPI2);

% calculate complexes density including complex with more than one protein
for iCom=1:size(ComplexNum,1)
    % compute the density of the complex
    % compute ppi of the proteins in the complex
    ProteinIndex = zeros(length(PPI1),1);
    interacInside = zeros(length(PPI1),1);
    interacInside1 = zeros(length(PPI1),1);
    for iProtein = 1:ComplexNum(iCom,1)
        ProteinIndex1 =strcmpi(ComplexProtein{iCom,1}(iProtein), PPI1);
        ProteinIndex2 =strcmpi(ComplexProtein{iCom,1}(iProtein), PPI2);
%         ProteinIndex = or(ProteinIndex,ProteinIndex1);
%         ProteinIndex = or(ProteinIndex,ProteinIndex2);
%         interacInside = interacInside+or(ProteinIndex1,ProteinIndex2);  
        interacInside1 = interacInside1 + xor(ProteinIndex1, ProteinIndex2); 
    end
    ppiInside = find(interacInside1==2);
    ppiOutside = find(interacInside1==1);
    complex_ppi{iCom,1}=[PPI1(ppiInside), PPI2(ppiInside)];
    complex_ppi{iCom,2}=[PPI1(ppiOutside), PPI2(ppiOutside)];
    complex_ppi{iCom,3}=ComplexProtein{iCom,1};    
    Degree(iCom,1) = length(ppiInside);
    Degree(iCom,2) = length(ppiOutside);
    Degree(iCom,3) = Degree(iCom,2) + Degree(iCom,1)*2;
    complex_density(iCom,1) = 2*Degree(iCom,1)/(ComplexNum(iCom,1)*(ComplexNum(iCom,1)-1));
end


% % calculate complexes density including complex with just one protein
% for iCom=1:size(Mat_Num,1)
%     ProteinIndex = zeros(length(DIP_ppi1),1);
%     interacInside = zeros(length(DIP_ppi1),1);
%     for iProtein = 1:Mat_Num(iCom,2)
%         ProteinIndex1 =strcmp(Mat_Protein{iCom,1}(iProtein), DIP_ppi1);
%         ProteinIndex2 =strcmp(Mat_Protein{iCom,1}(iProtein), DIP_ppi2);
%         ProteinIndex = or(ProteinIndex,ProteinIndex1);
%         ProteinIndex = or(ProteinIndex,ProteinIndex2);
%         interacInside = interacInside+or(ProteinIndex1,ProteinIndex2);        
%     end
%     complex_density(iCom,1) = 2*length(find(interacInside==2))/(Mat_Num(iCom,2)*(Mat_Num(iCom,2)-1));
%     complex_ppi{iCom,1}=[DIP_ppi1(ProteinIndex),DIP_Int_Type(ProteinIndex), DIP_ppi2(ProteinIndex)];
%     complex_ppi{iCom,2}=Mat_Protein{iCom,3};    
% end