% sort the cores and remove redundant clusters

function coreExpandClusterRank(idata, paths)
fprintf('sort the cores and remove redundant clusters ...\n');
icoreSize = 10;
fin=sprintf(['.\\dataset\\',char(paths(idata)),'\\coreExpandCluster', num2str(icoreSize), 'v5_1.mat']);
load(fin);%save(fnout,'coreSet','clusterNew','clusterNum','coreNum', 'attachSet','attachNum','coreScore');
fin=sprintf(['.\\dataset\\',char(paths(idata)),'\\proteinDegree.mat']);
load(fin);

totalProteinNum = size(proteinAllTmp,1);
totalInteraction = size(PPI1,1);

% compute the degree of each protein in coreSet and interaction  
[core_ppi core_density coreDegree] = clusterDensity(coreNum, coreSet, PPI1, PPI2);

% compute the degree of each protein in attachSet and interaction  
[attach_ppi attach_density attachDegree] = clusterDensity(attachNum, attachSet, PPI1, PPI2);

% compute the degree of each protein in cluster and interaction num and cluster density  
[cluster_ppi cluster_density clusterDegree] = clusterDensity(clusterNum, clusterNew, PPI1, PPI2);
% fnout=sprintf(['.\\dataset\\',char(paths(idata)),'\\ClusterDensity.mat']);
% save(fnout,'cluster_ppi',  'cluster_density', 'Degree'); 

% rank the Core
%----------------------
rankCore = [];
for iCore = 1:size(clusterNew,1)
    if (coreNum(iCore)>=2)
        M = clusterDegree(iCore,1) - coreDegree(iCore,1) - attachDegree(iCore,1);
        rankCore(iCore, 1) = logCoreScore(totalProteinNum,coreNum(iCore),coreDegree(iCore,3),...
            coreDegree(iCore,1),attachNum(iCore),M);
    else
        rankCore(iCore, 1) = coreScore(iCore,1);
    end
end
%--------------------
% sort the cluster by the rankCore
[valueRank indexRank] = sort(rankCore);
clusterSorted = clusterNew(indexRank);
coreSetSorted = coreSet(indexRank);
clusterNumSorted = clusterNum(indexRank);
coreNumSorted = coreNum(indexRank);
cluster_density = cluster_density(indexRank,:);
clusterDegree = clusterDegree(indexRank,:);
coreScoreSorted = coreScore(indexRank,:);

%----------------------
%%--remove some redundant clusters
loop = 1;
iCluster = 1;
while ( loop == 1)
    commProteinNum = [];
    for jCluster = iCluster+1:length(clusterSorted)
        commProteinNum(jCluster - iCluster, 1) = commCamp(clusterSorted{iCluster,1}, coreSetSorted{jCluster,1})/coreNumSorted(jCluster);
    end
    Index = find(commProteinNum < 1);
    clusterSorted = [clusterSorted(1:iCluster, 1); clusterSorted(Index+iCluster,1)];
    clusterNumSorted = [clusterNumSorted(1:iCluster, 1); clusterNumSorted(Index+iCluster,1)];
    coreSetSorted = [coreSetSorted(1:iCluster, 1); coreSetSorted(Index+iCluster,1)];
    coreNumSorted = [coreNumSorted(1:iCluster, 1); coreNumSorted(Index+iCluster,1)];
    valueRank = [valueRank(1:iCluster, 1); valueRank(Index+iCluster,1)];
    indexRank = [indexRank(1:iCluster, 1); indexRank(Index+iCluster,1)];
    cluster_density = [cluster_density(1:iCluster, 1); cluster_density(Index+iCluster,1)];
    clusterDegree = [clusterDegree(1:iCluster, :); clusterDegree(Index+iCluster,:)];
    coreScoreSorted = [coreScoreSorted(1:iCluster, :); coreScoreSorted(Index+iCluster,:)];
    iCluster = iCluster+1;
    if (iCluster > size(clusterSorted, 1))
        loop = 0;
    end
end
%-----------------------------
fprintf('rank and output the cores and clusters  ...\n');
% rank the cluster by the p_value
rankCluster = [];
for iCluster = 1:size(clusterSorted,1)
    if (clusterNumSorted(iCluster)>=2)
        interNum = nchoosek(clusterNumSorted(iCluster), 2);
        interAllNum = (totalProteinNum - clusterNumSorted(iCluster))*clusterNumSorted(iCluster);
        maxNum = min([interNum, fix(clusterDegree(iCluster, 3)/2)]);        
        xiNum = [];
        yiNum = [];
        for iNum = 0:maxNum
            xiNum(iNum+1, 1) = logCombine(nchoosek(clusterNumSorted(iCluster), 2), iNum) + ...
                logCombine((totalProteinNum - clusterNumSorted(iCluster))*clusterNumSorted(iCluster),...
                clusterDegree(iCluster, 3) - 2*iNum);
        end
        for iNum = clusterDegree(iCluster, 1) : maxNum
            yiNum(iNum-clusterDegree(iCluster, 1)+1, 1) = logCombine(nchoosek(clusterNumSorted(iCluster), 2), ...
                clusterDegree(iCluster, 1)) + logCombine((totalProteinNum - clusterNumSorted(iCluster))*clusterNumSorted(iCluster),...
                clusterDegree(iCluster, 3) - 2*iNum);    
        end
        M1 = max(xiNum)-500;
        xNum = log(sum(exp(xiNum-M1))) + M1;
        M2 = max(yiNum)-500;
        yNum = log(sum(exp(yiNum-M2))) + M2;
        rankCluster(iCluster, 1) = yNum - xNum; 
    else
        rankCluster(iCluster, 1) = 0;
    end
end 

[valueRank indexRank] = sort(rankCluster);
clusterRanked = clusterSorted(indexRank);
coreSetRanked = coreSetSorted(indexRank);
clusterNumRanked = clusterNumSorted(indexRank);
coreNumRanked = coreNumSorted(indexRank);
cluster_density = cluster_density(indexRank,:);
clusterDegree = clusterDegree(indexRank,:);

%save the results
fnout=sprintf(['.\\dataset\\',char(paths(idata)),'\\coreExpandClusterRanked', num2str(icoreSize), 'v5_1.mat']);
save(fnout,'clusterRanked','clusterNumRanked','coreSetRanked','coreNumRanked'); 

warning off;
% output xls file
outfile = sprintf(['.\\result\\',char(paths(idata)),'_outClusters.xls']);
for icluster = 1:size(clusterRanked,1)
    range = sprintf(['A',num2str(icluster)]);
    xlswrite(outfile, clusterRanked{icluster, 1},'outCluster',range);
    xlswrite(outfile, coreSetRanked{icluster, 1},'outCore',range);
end
fprintf('Done!\n');


